#ifndef BOBSHIELD_H
#define BOBSHIELD_H

#include "Arduino.h" // for byte data type
#include "SPI.h"
#include "GPGGA.h"
#include "Commands.h"

class BobShield
{	
	public:
		BobShield();

		uint8_t status();
		void clearBuffers();

		uint8_t* sweep(uint16_t numSamples, bool sendToDNT, bool sendBack);
		
		void dntReset();
		uint8_t dntBytesAvailable();
		void dntSendData(uint8_t* data, uint8_t length);
		uint8_t dntReceiveData(uint8_t* data, uint8_t max);

		void gpsSend();
		uint8_t gpsGet(uint8_t* data);
		uint8_t gpsSendGet(uint8_t* data);
		
		void flushBufferSPI();
		
		void writeDAC(uint16_t data, bool ch0, bool ch1);
		void readADC(bool ch0, bool ch1, bool toDNT, bool toMaster, uint8_t* ch1Data, uint8_t* ch2Data);

		void setBaudDNT(BaudOptions baud);
		
		uint8_t addOne(uint8_t data);

		bool getAck(int numTries);


	private:	
		void csh();
		void csl();
		void spiDelay();
		uint8_t slaveSelect_bm;
};

#endif
