#ifndef COMMANDS_H
#define COMMANDS_H

#define SLAVE_ACK 42

typedef enum 
{
	SlaveCommand_Dummy = 0x00,
	SlaveCommand_Status = 0x01,
	SlaveCommand_Sweep = 0x02,
	SlaveCommand_SendToDNT = 0x03,
	SlaveCommand_DNTNumAvailable = 0x04,
	SlaveCommand_DNTGet = 0x05,
	SlaveCommand_DNTReset = 0x06,
	SlaveCommand_GPSGet = 0x07,
	SlaveCommand_ReadADC = 0x09,
	SlaveCommand_WriteDAC = 0x0A,
	SlaveCommand_ChangeBaud = 0x0B,
	SlaveCommand_SpeedTest = 0x0C,
	SlaveCommand_ACK = 0x0D,
} SlaveCommand;

typedef enum
{
	Baud_9600 = 0x10,
	Baud_115200 = 0x20,
	Baud_230400 = 0x30,
} BaudOptions;

typedef enum
{
	Data_ToDNT = 0x10,
	Data_ToMaster = 0x20,
} DataOptions;

typedef enum
{
	Fit_ToDNT = 0x40,
	Fit_ToMaster = 0x80
} FitOptions;

typedef enum
{
	PipSelect_0 = 0x40,
	PipSelect_1 = 0x80,
} PipSelect;

#endif